VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   12975
   ClientLeft      =   750
   ClientTop       =   930
   ClientWidth     =   18000
   LinkTopic       =   "Form1"
   ScaleHeight     =   12975
   ScaleWidth      =   18000
   Begin VB.CommandButton BtnGoOn 
      Caption         =   "Weiter >>>"
      Height          =   495
      Left            =   2160
      TabIndex        =   1
      Top             =   0
      Width           =   2295
   End
   Begin VB.CommandButton BtnGoBack 
      Caption         =   "<<< Zurck"
      Height          =   495
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   2175
   End
   Begin VB.PictureBox Picture1 
      BorderStyle     =   0  'Kein
      Height          =   12375
      Left            =   0
      ScaleHeight     =   12375
      ScaleWidth      =   17895
      TabIndex        =   0
      Top             =   480
      Width           =   17895
      Begin VB.Timer timAniMouseClicks 
         Enabled         =   0   'False
         Left            =   8760
         Top             =   4920
      End
      Begin VB.Image imgAniMouse 
         Height          =   285
         Left            =   8160
         Top             =   4920
         Width           =   180
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Ein Paradebeispiel frs Command-Pattern ;-)
'Code zeigt grob das Zusammenspiel von Klassen mit dem Command-Entwurfsmuster
'und bildet die Grundlage fr eine Klassensammlung zur Realisierung eines
'interaktiven teils selbstablaufenden Tutorials
'hier jetzt der Einfachheit halber nur eine spezialisierte Command-Klasse CommandMouseMove
'momentan sieht man nur die Maus wie besoffen herumfahren.
'Der Weg der Maus wird bei jedem Programmstart zufllig neu generiert.
Implements ICommandListener
Private m_pl As ListOfPictureDisp
Private m_StoryBoard As StoryBoard
Private mAniMouse As AniMouse

Private Sub Form_Load()
    Picture1.ScaleMode = vbPixels
    Set m_pl = LoadAllPictures(App.Path)
    Set mAniMouse = MNew.AniMouse(imgAniMouse, m_pl.Item(0), m_pl.Item(1), m_pl.Item(2), m_pl.Item(3), MNew.Timer)
    Set Picture1.Picture = m_pl.Item(4)
    Set m_StoryBoard = New StoryBoard
    Set CCommand(m_StoryBoard).Parent = Me
    Randomize
    Dim cl1 As New CommandList
    With cl1
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
    End With
    Dim cl2 As New CommandList
    With cl2
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
    End With
    Dim cl3 As New CommandList
    With cl3
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
        .Add MNew.CommandMouseMove(MNew.Timer, mAniMouse, Rnd * 900, Rnd * 700)
    End With
    With m_StoryBoard
        .Add cl1
        .Add cl2
        .Add cl3
    End With
    ICommandListener_Done
End Sub

Private Sub ICommandListener_Done()
    BtnGoOn.Enabled = m_StoryBoard.CanExecute
    BtnGoBack.Enabled = m_StoryBoard.CanRollBack
End Sub

Function LoadAllPictures(aPath As String) As ListOfPictureDisp
    Dim pl As New ListOfPictureDisp
    With pl
        .Add LoadPicture(aPath & "\" & "00_MouseCursor.gif")
        .Add LoadPicture(aPath & "\" & "00_MouseCursorL.gif")
        .Add LoadPicture(aPath & "\" & "00_MouseCursorM.gif")
        .Add LoadPicture(aPath & "\" & "00_MouseCursorR.gif")
        .Add LoadPicture(aPath & "\" & "01_VS2017.bmp")
    End With
    Set LoadAllPictures = pl
End Function

Private Sub BtnGoOn_Click()
    m_StoryBoard.Execute
End Sub

Private Sub BtnGoBack_Click()
    m_StoryBoard.RollBack
End Sub

Private Sub Form_Resize()
    Dim L As Single: L = Picture1.Left
    Dim t As Single: t = Picture1.Top
    Dim W As Single: W = Me.ScaleWidth
    Dim H As Single: H = Me.ScaleHeight
    If W > 0 And H > 0 Then Picture1.Move L, t, W, H
End Sub
