VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "StoryBoard"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'eigentlich ist das wie eine CommandList bloss ohne die automatische Weiterfhrung der Commands
Implements ICommand
Implements ICommandListener
Private m_Arr() As ICommand
Private m_Count As Long
Private m_Index As Long
Private m_Incrm As Long
Private m_Parent As ICommandListener
'Public Event Done()
Private m_IsDone As Boolean

Private Sub Class_Initialize()
    ReDim m_Arr(0 To 3)
    m_IsDone = True
End Sub

Public Sub Add(aObj As ICommand)
    If UBound(m_Arr) = m_Count Then ReDim Preserve m_Arr(0 To m_Count * 2 - 1)
    Set m_Arr(m_Count) = aObj
    Set aObj.Parent = Me
    m_Count = m_Count + 1
End Sub

Public Property Get CanExecute() As Boolean
    If Not m_IsDone Then Exit Property
    CanExecute = 0 <= m_Index And m_Index < m_Count
End Property

Public Property Get CanRollBack() As Boolean
    If Not m_IsDone Then Exit Property
    CanRollBack = 0 < m_Index And m_Index <= m_Count
End Property
'Private Property Get Index() As Long
'    Index = m_Index
''    m_Index = m_Index + m_Incrm 'hier andersrum!
'End Property

Public Sub Execute()
    'If Not m_IsLastCmdDone Then Exit Sub
    m_Incrm = 1
    'm_IsLastCmdDone = False
    If Me.CanExecute Then
        m_IsDone = False
        m_Arr(m_Index).Execute
        m_Index = m_Index + m_Incrm
    End If
End Sub

Public Sub RollBack()
    'If Not m_IsLastCmdDone Then Exit Sub
    m_Incrm = -1
    'm_IsLastCmdDone = False
    If Me.CanRollBack Then
        m_IsDone = False
        m_Index = m_Index + m_Incrm
        m_Arr(m_Index).RollBack
    End If
End Sub

Private Sub ICommand_Execute()
    Me.Execute
End Sub

Private Property Set ICommand_Parent(RHS As ICommandListener)
    Set m_Parent = RHS
End Property

Private Sub ICommand_RollBack()
    Me.RollBack
End Sub

Private Sub ICommandListener_Done()
    m_IsDone = True
    m_Parent.Done
End Sub

